package eu.univento.lobby;

import eu.univento.commons.server.ServerType;
import eu.univento.core.api.server.ServerSettings;
import eu.univento.lobby.commands.DropItem;
import eu.univento.lobby.commands.Setloc;
import eu.univento.lobby.listeners.*;
import org.bukkit.Bukkit;
import org.bukkit.Difficulty;
import org.bukkit.GameMode;
import org.bukkit.World;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;

/**
 * main class...
 * @author joethei
 * @version 1.0
 */
public class Lobby extends JavaPlugin{

	private static Lobby instance;

	public static Lobby getInstance() {
		return instance;
	}

	
	@Override
	public void onEnable() {
		instance = this;
		PluginManager pm = Bukkit.getPluginManager();;
		pm.registerEvents(new Jumppads(), this);
		pm.registerEvents(new JoinQuit(), this);
		pm.registerEvents(new MenuEvents(), this);
		pm.registerEvents(new Events(), this);
		pm.registerEvents(new Menu(), this);
		pm.registerEvents(new PlayerHider(), this);
		pm.registerEvents(new ItemEvents(), this);
		pm.registerEvents(new FoundItems(), this);
		pm.registerEvents(new Parkour(), this);
        pm.registerEvents(new PetInteract(), this);
        pm.registerEvents(new PlayerInteract(), this);

		new Setloc(this, "setloc", "Setzt Teleport Punkte");

		new DropItem(this, "dropitem", "Setzt EasterEggs");
		
		if(ServerSettings.isDebug()) System.out.println("Befehle registriert");
		
		for(World w : Bukkit.getWorlds()) w.setDifficulty(Difficulty.PEACEFUL);

		ServerSettings.setGameMode(GameMode.ADVENTURE);
        ServerSettings.setLobby(true);
        ServerSettings.setServerType(ServerType.LOBBY);
		System.out.println(" Plugin ver." + getDescription().getVersion() + " gestartet");

	}
	
	@Override
	public void onDisable() {
		System.out.println("Plugin beendet");
	}

}